Program SimuladorDeLeyGeneralDelEstadoGaseoso;          {Carlos Gershenson}

Uses
	Graph,crt;

Const
     r=8.31451;

Var
     P,V,n,T:real;
     Pa,Va,na,Ta:real;
     c,d,e,f:byte;
     ca,da,ea,fa:byte;
     grDriver: Integer;
     grMode: Integer;
     ErrCode: Integer;
     g,fij,fija:char;
     s:string;

function ITS(r: real): String;
var
 S,s2: string;
 mau:boolean;
 neg:char;
 i,j,n:integer;
begin
 Str(r, S);
 i:=1;
 j:=1;
 while (s[i])<>'E'do
 begin
   If s[i] in ['0'..'9'] then
   begin
     s2[j]:=s[i];
     j:=j+1;
   end;
   i:=i+1;
 end;
 s2[0]:=chr(j-1);
 If s[15]='+' then
   mau:=true
 else
   mau:=false;
 n:=ord(s[17])-48;
 n:=n+ord(s[16])-48;
 j:=1;
 If mau then
 begin
    for i:=1 to n+1 do
    begin
      j:=j+1;
      s[j]:=s2[i];
    end;
    j:=j+1;
    s[j]:='.';
    for i:=n+2 to n+4 do
    begin
      j:=j+1;
      s[j]:=s2[i];
    end;
    s[0]:=chr(n+6);
 end
 else
 begin
    s[2]:='0';
    s[3]:='.';
    i:=1;
    while i< n do
    begin
      s[i+3]:='0';
      i:=i+1;
    end;
    j:=i+2;
    For i:=1 to 3 do
    begin
      j:=j+1;
      s[j]:=s2[i];
    end;
    s[0]:=chr(n+5);
 end;
 ITS := S;
 If r<0.000000001 then
   ITS:=' lim'+#26+' 0';
end;

Procedure ini;
begin
     p:=1;
     t:=273;
     n:=1;
     v:=n*r*t/p;
     fij:='v';
     g:=#0;
     c:=0;
     d:=0;
     e:=0;
     f:=0;
end;

Procedure letreros;

Begin
     SetFillstyle(1,9);
     SetColor(4);
     bar(0,0,getmaxx,getmaxy);
     OutTextXY(140,1,'SIMULADOR DE LEY GENERAL DEL ESTADO GASEOSO');
     OutTextXY(5,getmaxy-10,'Gershenson Tecnologies Inc. 1998');
     OutTextXY(getmaxx-90,getmaxy-10,'Esc, Salida');
     SetColor(0);
     s:='1)'+#24+' Temperatura';
     OutTextXY(5,50,s);
     s:='2)'+#25+' Temperatura';
     OutTextXY(5,60,s);
     s:='Q)'+#24+' Presin';
     OutTextXY(5,70,s);
     s:='W)'+#25+' Presin';
     OutTextXY(5,80,s);
     s:='A)'+#24+' Volmen';
     OutTextXY(5,90,s);
     s:='S)'+#25+' Volmen';
     OutTextXY(5,100,s);
     s:='Z)'+#24+' No. Moles';
     OutTextXY(5,110,s);
     s:='X)'+#25+' No. Moles';
     OutTextXY(5,120,s);
     OutTextXY(5,150,'3)Fijar Temperatura');
     OutTextXY(5,160,'E)Fijar Presin');
     OutTextXY(5,170,'D)Fijar Volmen');

     OutTextXY(5,250,'Temperatura(K):');
     OutTextXY(5,260,'Presin(atm)   :');
     OutTextXY(5,270,'Volmen(lt)    :');
     OutTextXY(5,280,'No. Moles(mol) :');
     OutTextXY(5,300,'Fijado:');

End;

Procedure datos;

begin
     SetColor(9);
     If ta <>t then Outtextxy(130,250,ITS(ta));
     If pa <>p then      Outtextxy(130,260,ITS(pa));
     If va <>v then      Outtextxy(130,270,ITS(va));
     If na <>n then      Outtextxy(130,280,ITS(na));
     If fija <>fij then
       Case fija of
         't':OutTextXY(80,300,'Temperatura');
         'p':OutTextXY(80,300,'Presin');
         'v':OutTextXY(80,300,'Volmen');
       end;
     SetColor(0);
     Outtextxy(130,250,ITS(t));
     Outtextxy(130,260,ITS(p));
     Outtextxy(130,270,ITS(v));
     Outtextxy(130,280,ITS(n));
     Case fij of
       't':OutTextXY(80,300,'Temperatura');
       'p':OutTextXY(80,300,'Presin');
       'v':OutTextXY(80,300,'Volmen');
     end;
end;

Procedure pinta;

var
   i,j,k:integer;

Begin
     ca:=c;
     da:=d;
     ea:=e;
     fa:=f;
     c:=4;
     If t<500 then c:=12;
     If t<400 then c:=14;
     If t<330 then c:=10;
     If t<300 then c:=2;
     If t<280 then c:=1;
     If t<200 then c:=3;
     If t<150 then c:=11;
     If t<80  then c:=15;
     d:=3;
     If p<8 then d:=4;
     If p<6 then d:=6;
     If p<4 then d:=8;
     If p<2 then d:=10;
     If p<1 then d:=12;
     e:=5;
     If v<4000 then e:=4;
     If v<3000 then e:=3;
     If v<2000 then e:=2;
     If v<1000 then e:=1;
     f:=5;
     If n<10 then f:=4;
     If n<6 then f:=3;
     If n<4 then f:=2;
     If n<2 then f:=1;

     SetColor(9);
     SetFillStyle(1,9);
     If (ea<>e)or(da>d)or(fa>f) then
       bar(250,45,getmaxx-60,75+(70*ea));
     SetColor(0);
     rectangle(250,45,getmaxx-60,75+(70*e));
     SetColor(c);
     SetFillStyle(1,c);
     For i:= 0 to 7 do
       For j:=0 to 9 do
         For k:=1 to f do
         begin
           Fillellipse(269+(k*5)+(j*30),60+(10*i*e),d,d);
         end;

End;

Procedure gas;

Begin
     letreros;
     ini;
     repeat
       ta:=t;
       pa:=p;
       va:=v;
       na:=n;
       fija:=fij;
       Case Upcase(g) of
         '1':if fij<>'t' then
             begin
               t:=t+5;
               If fij='v' then
                 p:=n*r*t/v
               else
                 v:=n*r*t/p
             end;
         '2':if fij<>'t' then
             begin
               t:=t-5;
               If fij='v' then
                 p:=n*r*t/v
               else
                 v:=n*r*t/p
             end;
         '3':begin
               fij:='t';
             end;
         'Q':if fij<>'p' then
             begin
               p:=p+0.2;
               If fij='v' then
                 t:=(p*v)/(n*r)
               else
                 v:=n*r*t/p
             end;
         'W':if fij<>'p' then
             begin
               p:=p-0.2;
               If fij='v' then
                 t:=(p*v)/(n*r)
               else
                 v:=n*r*t/p
             end;
         'E':begin
               fij:='p';
             end;
         'A':if fij<>'v' then
             begin
               v:=v+50;
               If fij='p' then
                 t:=(p*v)/(n*r)
               else
                 p:=n*r*t/v
             end;
         'S':if fij<>'v' then
             begin
               v:=v-50;
               If fij='p' then
                 t:=(p*v)/(n*r)
               else
                 p:=n*r*t/v
             end;
         'D':begin
               fij:='v';
             end;
         'Z':begin
               n:=n+1;
               If fij='p' then
                 t:=(p*v)/(n*r)
               else
                 p:=n*r*t/v
             end;
         'X':begin
               n:=n-1;
               If n>0 then
                 If fij='p' then
                   t:=(p*v)/(n*r)
                 else
                   p:=n*r*t/v
             end;
       end;
       If (t<=0) or (Round(p*1000)<=0) or(v<=0) or(n<=0)then
       begin
        t:=ta;
        v:=va;
        p:=pa;
        n:=na;
       end;
       datos;
       pinta;
       g:=readkey;
      until g=#27;
End;

Begin
     grDriver := Detect;
     InitGraph(grDriver, grMode,' ');
     ErrCode := GraphResult;
     if ErrCode = grOk then
     begin
       gas;
       CloseGraph;
     end
     else
       Writeln('Graphics error:', GraphErrorMsg(ErrCode));
End.
