Program LifeGame3D;                      {Carlos Gershenson}

Uses
     Graph,crt;

Type
     life=array[0..11,0..11,0..11] of boolean;


Var
     color:array[1..10]of word;
     l,l2:life;
     x,y,z,x2d,y2d,xa,ya,za:real;
     f,car,g:char;
     A:text;
     i,j,k,c,t,d,n,na,p:integer;
     grDriver: Integer;
     grMode: Integer;
     ErrCode: Integer;
     torus:boolean;

function ITS(I: real): String;
var
 S: string;
begin
 Str(I:1:1, S);
 ITS:= S;
end;

Function Cx(x:real):integer;
begin
     Cx:=round((x*20)+(getmaxx div 2));
end;

Function Cy(y:real):integer;
begin
     If y>=0 then
       Cy:=round((getmaxy div 2)-(y*20))
     else
       Cy:=round((abs(y)*20)+(getmaxy div 2));
end;

Procedure Rotate(var x,y,z:real);
begin
     x:=x*COS(pi/20) - y*SIN(pi/20);
     y:=y*COS(pi/20) + x*SIN(pi/20);
end;

Procedure Is(x,y,z:real;var x2d,y2d:real);
begin
     x2d:=y-x;
     y2d:=-(x+y-(2*z))/2;
end;

Procedure Check(var CH:integer);
var
  res:integer;
begin
  Repeat
  {$I-}
    readln(CH);
    res:=IOresult;
  {$I+}
  if res<>0 then
  begin
    writeln('Error, trate de nuevo');
  end;
  until res=0;
end;

Procedure cubo(x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,x7,y7,x8,y8:integer);

Begin
     OutTextXY(0,0 ,'Generacin:');
     OutTextXY(0,15,'Delay:');
     OutTextXY(0,30,'Clulas:');
     SetColor(14);
     OutTextXY(250,0,'JUEGO DE LA VIDA 3D');
     OutTextXY(200,getmaxy-10,'Carlos Gershenson          Fundacin Arturo Rosenblueth');
     SetColor(9);
     OutTextXY(0,getmaxy-10,'Esc, Salida');

     color[1]:=15;
     color[2]:=14;
     color[3]:=13;
     color[4]:=12;
     color[5]:=11;
     color[6]:=7;
     color[7]:=6;
     color[8]:=5;
     color[9]:=4;
     color[10]:=3;
     Case g of
        '0':begin
              Randomize;
              For i:=1 to 10 do
                For j:=1 to 10 do
                  For k:=1 to 10 do
                    If random(100)<p then
                      l[i,j,k]:=true
                    else
                      l[i,j,k]:=false;

            end;
        '1':Assign(A,'lifemap1.pas');
        '2':Assign(A,'lifemap2.pas');
        '3':Assign(A,'lifemap3.pas');
        '4':Assign(A,'lifemap4.pas');
        '5':Assign(A,'lifemap5.pas');
        '6':Assign(A,'lifemap6.pas');
        '7':Assign(A,'lifemap7.pas');
        '8':Assign(A,'lifemap8.pas');
        '9':Assign(A,'lifemap9.pas');

     end;
     If g<>'0' then
     begin
       reset(A);
       For i:=1 to 10 do
         For j:=1 to 10 do
           For k:=1 to 10 do
           begin
             read(A,car);
             If car='X' then
               l[i,j,k]:=true
             else
               l[i,j,k]:=false;
           end;
     end;
       t:=1;
         For i:=1 to 10 do
           For j:=1 to 10 do
             For k:=1 to 10 do
               If (l[i,j,k]=true) then
               begin
                 x:=i;y:=j;z:=k;
                 Rotate(x,y,z);
                 SetColor(color[i]);
                 IS(x,y,z,x2d,y2d);
                 Circle(Cx(x2d),Cy(y2d),10);
               end;
     Repeat
       Repeat
         SetColor(15);
         OutTextXY(87,0,ITS(t));
         OutTextXY(87,15,ITS(d));
         OutTextXY(87,30,ITS(n));
         na:=n;
         n:=0;
         If torus then
         begin
           For i:=1 to 10 do
             For j:=1 to 10 do
               begin
                 l[i,j,0]:=l[i,j,10];
                 l[i,0,j]:=l[i,10,j];
                 l[0,j,i]:=l[10,j,i];
                 l[i,j,11]:=l[i,j,1];
                 l[i,11,j]:=l[i,1,j];
                 l[11,j,i]:=l[1,j,i];
               end;
           For i:=1 to 10 do
               begin
                 l[i,0,0]:=l[i,10,10];
                 l[0,i,0]:=l[10,i,10];
                 l[0,0,i]:=l[10,10,i];
                 l[i,0,11]:=l[i,10,1];
                 l[i,11,0]:=l[i,1,10];
                 l[11,0,i]:=l[1,10,i];
                 l[0,11,i]:=l[10,1,i];
                 l[11,i,0]:=l[1,i,10];
                 l[0,i,11]:=l[10,i,1];
                 l[i,11,11]:=l[i,1,1];
                 l[11,i,11]:=l[1,i,1];
                 l[11,11,i]:=l[1,1,i];
               end;
                 l[0,0,0]:=l[10,10,10];
                 l[11,0,0]:=l[1,10,10];
                 l[0,0,11]:=l[10,10,1];
                 l[0,11,0]:=l[10,1,10];
                 l[11,11,0]:=l[1,1,10];
                 l[11,0,11]:=l[1,10,1];
                 l[0,11,11]:=l[10,1,1];
                 l[11,11,11]:=l[1,1,1];
         end;

         SetColor(9);
         line(x1,y1,x2,y2);
         line(x1,y1,x4,y4);
         line(x1,y1,x5,y5);
         line(x2,y2,x6,y6);
         line(x4,y4,x8,y8);
         line(x5,y5,x6,y6);
         line(x5,y5,x8,y8);
         line(x7,y7,x6,y6);
         line(x7,y7,x8,y8);

         l2:=l;

         For i:=1 to 10 do
           For j:=1 to 10 do
             For k:=1 to 10 do
             begin
               c:=0;
               If l2[i+1,j,k] then
                 c:=c+1;
               If l2[i-1,j,k] then
                 c:=c+1;
               If l2[i,j,k+1] then
                 c:=c+1;
               If l2[i,j,k-1] then
                 c:=c+1;
               If l2[i,j-1,k] then
                 c:=c+1;
               If l2[i,j+1,k] then
                 c:=c+1;
               If l2[i+1,j+1,k] then
                 c:=c+1;
               If l2[i-1,j-1,k] then
                 c:=c+1;
               If l2[i+1,j,k+1] then
                 c:=c+1;
               If l2[i-1,j,k-1] then
                 c:=c+1;
               If l2[i,j+1,k+1] then
                 c:=c+1;
               If l2[i,j-1,k-1] then
                 c:=c+1;
               If l2[i-1,j+1,k] then
                 c:=c+1;
               If l2[i+1,j-1,k] then
                 c:=c+1;
               If l2[i-1,j,k+1] then
                 c:=c+1;
               If l2[i+1,j,k-1] then
                 c:=c+1;
               If l2[i,j-1,k+1] then
                 c:=c+1;
               If l2[i,j+1,k-1] then
                 c:=c+1;
               If l2[i+1,j+1,k+1] then
                 c:=c+1;
               If l2[i-1,j+1,k+1] then
                 c:=c+1;
               If l2[i+1,j-1,k+1] then
                 c:=c+1;
               If l2[i+1,j+1,k-1] then
                 c:=c+1;
               If l2[i-1,j-1,k+1] then
                 c:=c+1;
               If l2[i+1,j-1,k-1] then
                 c:=c+1;
               If l2[i-1,j+1,k-1] then
                 c:=c+1;
               If l2[i-1,j-1,k-1] then
                 c:=c+1;


               If l2[i,j,k] then
                 begin
                 n:=n+1;
                 If (c<4) or (c>5) then
                   l[i,j,k]:=false;
                 end
               else
                 If c=5 then
                   l[i,j,k]:=true;

               If (l[i,j,k]=false) and (l2[i,j,k]=true) then
               begin
                 Setcolor(0);
                 x:=i;y:=j;z:=k;
                 Rotate(x,y,z);
                 IS(x,y,z,x2d,y2d);
                 Circle(Cx(x2d),Cy(y2d),10);
               end;

               If (l2[i,j,k]=false) and (l[i,j,k]=true) then
               begin
                 x:=i;y:=j;z:=k;
                 Rotate(x,y,z);
                 SetColor(color[i]);
                 IS(x,y,z,x2d,y2d);
                 Circle(Cx(x2d),Cy(y2d),10);
               end;
             end;
         SetColor(9);
         line(x3,y3,x2,y2);
         line(x3,y3,x4,y4);
         line(x3,y3,x7,y7);
         delay(d);
         SetColor(0);
         OutTextXY(87,0,ITS(t));
         OutTextXY(87,15,ITS(d));
         OutTextXY(87,30,ITS(na));
         t:=t+1;

       until keypressed;
       f:=readkey;
       Case f of
         #072:d:=d+50;
         #080:d:=d-50;
       end;
       If d<0 then d:=0;
     until f=#27;
End;

Procedure Porcentaje;
begin
     clrscr;
     Write('Inserte el porcentaje probable de clulas que iniciarn en el aleatorio:');
     check(p);
end;

Begin
     torus:=true;
     d:=200;
     p:=15;
     Repeat
       repeat
         clrscr;
         writeln('                 Juego de la Vida');
         writeln;
         writeln('Oprima una de las siguientes teclas:');
         writeln('  (1-9) Abrir Archivo');
         writeln('  (0)   Aleatorio ');
         write('  (T)   Hipertoroide ');
         If torus then
           writeln('(activado)')
         else
           writeln('(desactivado)');
         writeln('  (P)   Porcentaje en Aleatorio (',p,'/100)');
         writeln('  (Esc) Salida');
         g:=readkey;
         If g=#27 then Halt;
         If Upcase(g)='T' then
           If torus then
              torus:=false
           else
              torus:=true;
         If Upcase(g)='P' then Porcentaje;
       until (g in ['0'..'9']);
     grDriver := Detect;
     InitGraph(grDriver, grMode,' ');
     ErrCode := GraphResult;
     if ErrCode = grOk then
     begin
cubo(319,Cy(10),Cx(-8.3),Cy(4.27),Cx(3),Cy(0.1),Cx(11.44),Cy(5.84),319,239,Cx(-8.3),Cy(-5.7),Cx(3),Cy(-9.9),Cx(11.44),Cy(-4));
       If g<>'0' then Close(A);
       CloseGraph;
     end
     else
       Writeln('Graphics error:', GraphErrorMsg(ErrCode));
     until g=#0;
End.
