{$B-}
{}
{}
Program arbolb;                       {Carlos Gershenson}

Uses
	crt;
Const
        maxkeys=4;
        maxchild=5;
        maxwkeys=5;
        maxwchild=6;
        nokey='@';
        no=false;
        yes=true;
        null=-1;


Type
        BTPage=record
          keycount:integer;
          key:array[1..maxkeys] of char;
          child:array[1..maxchild] of integer;
        end;
Var

	btfd:file of BTPage;
        promoted:boolean;
        root,promorrn,minkeys,pagesize:integer;
        promokey,key,g:char;

function FileExists(FileName: String): Boolean;
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
{ FileMode := 0;  { Set file access to read only }
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

Function btopen:boolean;

begin
        assign(btfd,'b');
        If FileExists('b') then
        begin
          Reset(btfd);
          btopen:=true;
        end
        else
          btopen:=false;
end;

Function getroot:integer;

var
        root:BTPage;

begin
        seek(btfd,0);
        if not eof (btfd) then
        begin
          read(btfd,root);
          getroot:=root.keycount;
        end
        else
          Writeln('Error: No se encontro la raiz');
end;

Function getpage:integer;

begin
        getpage:=filesize(btfd);
end;

Procedure pageinit(var ppage:BTPage);

var
        j:integer;

begin
        For j:=1 to maxkeys do
        begin
          ppage.key[j]:=nokey;
          ppage.child[j]:=null;
        end;
        ppage.child[maxkeys+1]:=null;
end;

Procedure putroot(root:integer);

var
        rootrrn:BTPage;

begin
        seek(btfd,0);
        rootrrn.keycount:=root;
        pageinit(rootrrn);
        write(btfd,rootrrn);
end;

Procedure btread(rrn:integer;var pageptr:BTPage);
begin
        seek(btfd,rrn);
        read(btfd,pageptr);
end;

Procedure btwrite(rrn:integer; pageptr:BTPage);
begin
        seek(btfd,rrn);
        write(btfd,pageptr);
end;

Function createroot(key:char;left,right:integer):integer;

var
        page:BTPage;
        rrn:integer;

begin
        rrn:=getpage;
        pageinit(page);
        page.key[1]:=key;
        page.child[1]:=left;
        page.child[2]:=right;
        page.keycount:=1;
        btwrite(rrn,page);
        putroot(rrn);
        createroot:=rrn;
end;

Function createtree:integer;

var
        rootrrn:integer;

begin
        rewrite(btfd);
        Write('Dame la raiz: ');
        key:=readkey;
        writeln(key);
        rootrrn:=getpage;
        putroot(rootrrn);
        createtree:=createroot(key,null,null);
end;

Function searchnode(key:char;ppage:BTPage;var pos:integer):boolean;

var
        i:integer;

begin
        i:=1;
        while (i<=ppage.keycount)and(key>ppage.key[i])do
          i:=i+1;
        pos:=i;
        if (pos<=ppage.keycount)and(key>ppage.key[pos])then
          searchnode:=yes
        else
          searchnode:=no;
end;

Procedure insinpage(key:char;rchild:integer;var ppage:BTPage);

var
        i:integer;

begin
        i:=ppage.keycount+1;
        while (key<ppage.key[i-1])and(i>1)do
        begin
          ppage.key[i]:=ppage.key[i-1];
          ppage.child[i+1]:=ppage.child[i];
          i:=i-1;
        end;
        ppage.keycount:=ppage.keycount+1;
        ppage.key[i]:=key;
        ppage.child[i+1]:=rchild;
end;

Procedure split(key:char;rchild:integer;var poldpage:BTPage;var promokey:char;
          var promorchild:integer;var pnewpage:BTPage);

var
        i:integer;
        workkeys:array[1..maxwkeys]of char;
        workch:array[1..maxwchild]of integer;

begin
        for i:=1 to maxkeys do
        begin
          workkeys[i]:=poldpage.key[i];
          workch[i]:=poldpage.child[i];
        end;
        workch[maxkeys+1]:=poldpage.child[maxkeys+1];
        i:=maxkeys+1;
        While (key<workkeys[i-1])and(i>1) do
        begin
          workkeys[i]:=workkeys[i-1];
          workch[i+1]:=workch[i];
          i:=i-1;
        end;
        workkeys[i]:=key;
        workch[i+1]:=rchild;
        promorchild:=getpage;
        pageinit(pnewpage);
        for i:=1 to minkeys do
        begin
          poldpage.key[i]:=workkeys[i];
          poldpage.child[i]:=workch[i];
          pnewpage.key[i]:=workkeys[i+1+minkeys];
          pnewpage.child[i]:=workch[i+1+minkeys];
          poldpage.key[i+minkeys]:=nokey;
          poldpage.child[i+1+minkeys]:=null;
        end;
        poldpage.child[1+minkeys]:=workch[minkeys+1];
        if odd(maxkeys) then
        begin
          pnewpage.key[minkeys+1]:=workkeys[maxwkeys];
          pnewpage.child[minkeys+2]:=workch[maxwchild];
          pnewpage.child[minkeys+1]:=workch[maxwchild-1];
        end
        else
        begin
          pnewpage.child[minkeys+1]:=workch[maxwchild];
          pnewpage.keycount:=maxkeys-minkeys;
          poldpage.keycount:=minkeys;
          promokey:=workkeys[minkeys+1];
        end;

end;


Function insert(rrn:integer;key:char;var promorchild:integer;var promokey:char):boolean;

Var
        page,newpage:BTPage;
        found,promoted:boolean;
        pos,pbrrn:integer;
        pbkey:char;

Begin
     If rrn=null then
     begin
       promokey:=key;
       promorchild:=null;
       insert:=yes;
     end
     else
     begin
       btread(rrn,page);
       found:=searchnode(key,page,pos);
       if found then
       begin
         writeln('Error: la llave ya existe');
         insert:=no;
       end
       else
       begin
         promoted:=insert(page.child[pos],key,pbrrn,pbkey);
         if not promoted then
           insert:=no
         else
         begin
           If (page.keycount<maxkeys)then
           begin
             insinpage(pbkey,pbrrn,page);
             btwrite(rrn,page);
             insert:=no;
           end
           else
           begin
             split(pbkey,pbrrn,page,promokey,promorchild,newpage);
             btwrite(rrn,page);
             btwrite(promorchild,newpage);
             insert:=yes;
           end;
         end;
       end;
     end;
end;

Procedure insertar;
begin
     Writeln('Cada tecla apretada sera registrada');
     Writeln('Excepto Esc=Salida');
     key:=readkey;
     writeln(key);
     While key <>#27 do
     begin
       promoted:=insert(root,key,promorrn,promokey);
       If promoted then
         root:=createroot(promokey,root,promorrn);
       key:=readkey;
       writeln(key);
     end;
end;

Procedure Buscar;

var
        key:char;
        pos,i,fs:integer;
        bt:BTPage;
        found:boolean;

begin
     Write('Dame la letra a buscar: ');
     key:=readkey;
     writeln(key);
     pos:=0;
     found:=false;
     Reset(btfd);
     fs:=(filesize(btfd){ div pagesize});
     while (pos<fs)and(found=false) do
     begin
       inc(pos);
       read(btfd,bt);
       For i:=1 to maxkeys do
         If key = bt.key[i] then
           found:=true;
     end;
     If found then
     begin
       Writeln('El dato esta en el registro ',pos,', posicion ',i);
     end
     else
       Writeln('No se encontro el dato');
     Writeln('Presione cualquier tecla para continuar...');

     key:=readkey;

end;


Procedure Mostrar;

var
        key:char;
        pos,p,i,k,fs,l:integer;
        bt:BTPage;
        found:boolean;

Procedure search(root:integer; i:integer; b:BTPage);
var
        j,k:integer;

begin
     inc(i);
     writeln;
     seek(btfd,root);
     gotoxy((i-1)*10,wherey);
     read(btfd,b);
     For j:=1 to maxkeys do
       If b.key[j]='@' then
         write(' ')
       else
         write(b.key[j],' ');
     For j:=1 to maxchild do
       If b.child[j]<>-1 then
       begin
         search(b.child[j],i,b);
       end;
     {i:=1-1;}
end;

begin
     clrscr;
     pos:=0;
     p:=0;
     k:=0;
     found:=false;
     Reset(btfd);
     fs:=(filesize(btfd){ div pagesize});
     search(root,k,bt);
     {for l:=1 to filesize(btfd) do
     begin
       search(l,k,bt);
       readln;
     end;
     {while (pos<fs)and(found=false) do
     begin
       inc(pos);
       If (fs div 2)+2 > pos then
         p:=p+1
       else
         p:=p-1;
       read(btfd,bt);
       For i:=1 to maxkeys do
         If bt.key[i]='@' then
           write(' ')
         else
           write(bt.key[i],' ');
         write('            ');
       For i:=1 to maxchild do
         If bt.child[i]=-1 then
           write(' ')
         else
           write(bt.child[i],' ');
    write('            ');
            write(' ',bt.keycount);
       writeln;
     end;
     } Writeln;
     Writeln('Presione cualquier tecla para continuar...');

     key:=readkey;

end;

Begin
     clrscr;
     minkeys:=maxkeys div 2;
     pagesize:=sizeof(BTPage);
     If btopen then
       root:=getroot
     else
       root:=createtree;
     Repeat
       clrscr;
       Writeln('1)Insertar');
       Writeln('2)Buscar');
       Writeln('3)Mostrar');
       Writeln('4)Salida');
       repeat g:=readkey until g in ['1'..'4'];
       Case g of
         '1':insertar;
         '2':buscar;
         '3':mostrar;
       end;
     until g='4';
     close(btfd);
End.
