Program Hashish;                       {Carlos Gershenson}

Uses
	crt;

const
        max=308;
type
        cad=string[13];
        p=^nodo;
        nodo=record
          rfc:cad;
          nom:string[10];
          fl:boolean;
          n:p;
        end;

Var
	a:array [1..max] of nodo;
        i:integer;
        g:char;
        c:string[10];
        r:cad;
        num:integer;


Function hash(r:cad):integer;
var
   h:integer;
   err:boolean;

begin
     h:=0;
     For i:=1 to 6 do
       h:=ord(r[i])-48+h;
     For i:=7 to 10 do
       h:=ord(r[i])-64+h;
     For i:=11 to 13 do
       If r[i] in ['0'..'9'] then
         h:=ord(r[i])-48+h
       else
         h:=ord(r[i])-54+h;
     If (h>max)or(h<1) then
       begin writeln('Error, trate de nuevo');readln;end;
     hash:=h;
end;


Procedure insertar;

  procedure ins;

  var  aux,aux2,aux3:p;

  begin
       aux2:= a[num].n;
       While aux2<>nil do
       begin
         aux3:=aux2;
         aux2:=aux2^.n;
       end;
       new(aux);
       aux^.rfc:=r;
       aux^.nom:=c;
       aux^.fl:=false;
       aux^.n:=nil;
       aux2:=aux;
       If a[num].n=nil then
         a[num].n:=aux2
       else
         aux3^.n:=aux2;
  end;

begin
     write('Nombre: ');readln(c);
     write('RFC:    ');readln(r);
     num:=hash(r);
     If not a[num].fl then
     begin
       a[num].rfc:=r;
       a[num].nom:=c;
       a[num].fl:=true;
     end
     else
       ins;
end;

Procedure buscar;

  procedure bus;

  var  aux:p;
       flag:boolean;

  begin
       flag:=false;
       If a[num].rfc=r then
       begin
         writeln('RFC ',a[num].rfc,' encontrado en la posicin ',num);
         writeln(a[num].nom);
         flag:=true;
       end
       else
       begin
         aux:= a[num].n;
         While (aux<>nil){or (not flag)} do
         begin
           If aux^.rfc=r then
           begin
             writeln('RFC ',aux^.rfc,' encontrado en la posicin ',num);
             writeln(aux^.nom);
             flag:=true;
           end;
           aux:=aux^.n;
         end;
       end;
  end;

begin
     write('RFC:    ');readln(r);
     num:=hash(r);
     if not a[num].fl then
       writeln('No se encontro el RFC')
     else
       bus;
     Writeln('Presione Enter...');
     readln;
end;


Begin
     clrscr;
     For i:=1 to max do
     begin
       a[i].fl:=false;
       a[i].n:=nil;
     end;
     Repeat
       clrscr;
       Writeln('Favor de usar MAYUSCULAS');
       Writeln;
       Writeln('1)Insertar');
       Writeln('2)Buscar');
       Writeln('3)Salida');
       repeat g:=readkey until g in ['1'..'3'];
       Case g of
         '1':insertar;
         '2':buscar;
       end;
     until g='3';
End.
